
#     this is loaded into the DataAcquisitionControl namespace

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable INFO ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable allservers 0

    variable HistEnable 0
    variable XferEnable 0

#    code (int)  state (string)

#       0           stopped
#       1           going
#       2           reset
#       3           setting up
#       4           changing to going
#       5           changing to stopped
#       6           error   
#       7           changing to reset
#       8           undefined 
#       9           executing

    variable AcqCode 8
    variable AcqState "Unknown"
    variable AcqInfo "Unknown"

    foreach server $::DataAcquisition::ACQSERVERS {set ::DataAcquisition::AcqSysCode($server) 8}
    foreach server $::DataAcquisition::ACQSERVERS {set ::DataAcquisition::AcqSysState($server) "Unknown"}

    variable AcqParameter "None"
    variable AcqSetOption "None"
    variable AcqGetOption "Null"

    variable JS ""
    variable INFO ""


   proc  show_variables {} {
       variable AcqCode 
       variable AcqState
       variable AcqInfo
        global DataAcquisitionControlServerHost
        global MIDAS_DataAcquisitionControlServer_Exists
       variable AcqParameter
       variable AcqSetOption
       variable AcqGetOption
       variable HistEnable
       variable XferEnable
       variable allservers

       InsertLog "allservers=$allservers"
       InsertLog "AcqServer=$::DataAcquisition::ACQSERVER"
       InsertLog "AcqCode=$AcqCode; AcqState=$AcqState; AcqInfo=$AcqInfo"
       InsertLog "AcqParameter=$AcqParameter; AcqSetOption=$AcqSetOption; AcqGetOption=$AcqGetOption"
       InsertLog "HistEnable=$HistEnable; XferEnable=$XferEnable"

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists]} then {
         InsertLog "MIDAS_DataAcquisitionControlServer_Exists = $MIDAS_DataAcquisitionControlServer_Exists"
       }

       if {[info exists DataAcquisitionControlServerHost]} then {
         InsertLog "DataAcquisitionControlServerHost = $DataAcquisitionControlServerHost"
       }
   }

    proc do_reset {} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        global MIDAS_DataAcquisitionControlServer_Exists
        variable AcqParameter
        variable allservers

      set BAK $::DataAcquisition::ACQSERVER

      foreach acqserver $::DataAcquisition::ACQSERVERS {
          if {$allservers == 0 && $acqserver != $::DataAcquisition::ACQSERVER} continue

          set ::DataAcquisition::ACQSERVER $acqserver

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists]} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoReset "$AcqParameter"} m]
       } else {
           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__DoReset "$AcqParameter"} m]
       }

        if {$rc != 0} {
            InsertLog "RESET returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "RESET returned $m ([format "0x%x" $m])"
#            InsertLog "RESET returned $m"
        }

      }

      set ::DataAcquisition::ACQSERVER $BAK

    }

    proc do_setup {} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        global MIDAS_DataAcquisitionControlServer_Exists
        variable AcqParameter
        variable allservers

      set BAK $::DataAcquisition::ACQSERVER

      foreach acqserver $::DataAcquisition::ACQSERVERS {
          if {$allservers == 0 && $acqserver != $::DataAcquisition::ACQSERVER} continue

          set ::DataAcquisition::ACQSERVER $acqserver

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists]} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoSetUp "$AcqParameter"} m]
       } else {
           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__DoSetUp "$AcqParameter"} m]
       }

        if {$rc != 0} {
            InsertLog "SETUP returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "SETUP returned $m ([format "0x%x" $m])"
#            InsertLog "SETUP returned $m"
        }

      }

      set ::DataAcquisition::ACQSERVER $BAK

    }

    proc do_stop {} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        global MIDAS_DataAcquisitionControlServer_Exists
        variable AcqParameter
        variable allservers

      set BAK $::DataAcquisition::ACQSERVER

      foreach acqserver $::DataAcquisition::ACQSERVERS {
          if {$allservers == 0 && $acqserver != $::DataAcquisition::ACQSERVER} continue

          set ::DataAcquisition::ACQSERVER $acqserver

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists]} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoStop "$AcqParameter"} m]
       } else {
           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__DoStop "$AcqParameter"} m]
       }

        if {$rc != 0} {
            InsertLog "STOP returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "STOP returned $m ([format "0x%x" $m])"
#           InsertLog "STOP returned $m"
        }

      }

      set ::DataAcquisition::ACQSERVER $BAK

    }

    proc do_go {} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        global MIDAS_DataAcquisitionControlServer_Exists
        variable AcqParameter
        variable allservers

      set BAK $::DataAcquisition::ACQSERVER

      foreach acqserver $::DataAcquisition::ACQSERVERS {
          if {$allservers == 0 && $acqserver != $::DataAcquisition::ACQSERVER} continue

          set ::DataAcquisition::ACQSERVER $acqserver

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists]} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoGo "$AcqParameter"} m]
       } else {
           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__DoGo "$AcqParameter"} m]
       }

        if {$rc != 0} {
            InsertLog "GO returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "GO returned $m ([format "0x%x" $m])"
#            InsertLog "GO returned $m"
        }

      }

      set ::DataAcquisition::ACQSERVER $BAK

    }

    proc do_setopt {option} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        global MIDAS_DataAcquisitionControlServer_Exists
        variable AcqSetOption
        variable allservers

     set AcqSetOption $option

      set BAK $::DataAcquisition::ACQSERVER

      foreach acqserver $::DataAcquisition::ACQSERVERS {
          if {$allservers == 0 && $acqserver != $::DataAcquisition::ACQSERVER} continue

          set ::DataAcquisition::ACQSERVER $acqserver

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists]} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoOption "$AcqSetOption"} m]
       } else {
           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__DoOption "$AcqSetOption"} m]
       }

        if {$rc != 0} {
            InsertLog "DO OPTION returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "DO OPTION returned $m ([format "0x%x" $m])"
#            InsertLog "DO OPTION returned $m"
        }

      }

      set ::DataAcquisition::ACQSERVER $BAK

    }

    proc do_getopt {option} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        global MIDAS_DataAcquisitionControlServer_Exists
        variable AcqGetOption
        variable allservers

      set AcqGetOption $option

      set BAK $::DataAcquisition::ACQSERVER
      set response ""

      foreach acqserver $::DataAcquisition::ACQSERVERS {
          if {$allservers == 0 && $acqserver != $::DataAcquisition::ACQSERVER} continue

          set ::DataAcquisition::ACQSERVER $acqserver

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists]} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetOption "$AcqGetOption"} m]
       } else {
           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__GetOption "$AcqGetOption"} m]
           if {$rc == 0} {set m [second $m]}
       }

        if {$rc != 0} {
            InsertLog "GET OPTION returned with an error\n$m\n$errorCode\n$errorInfo"
            set m "Null"
        } else {
#            InsertLog "GetOption with parameter $AcqGetOption returned $m"
        }

        append response "$m "

      }

      set ::DataAcquisition::ACQSERVER $BAK

        return "$response"
    }

    proc do_getstate {} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        global MIDAS_DataAcquisitionControlServer_Exists
        variable allservers
        variable AcqCode 
        variable AcqState
        variable AcqInfo 

      set BAK $::DataAcquisition::ACQSERVER

      foreach server $::DataAcquisition::ACQSERVERS {set ::DataAcquisition::AcqSysCode($server) 8}
      foreach server $::DataAcquisition::ACQSERVERS {set ::DataAcquisition::AcqSysState($server) "Unknown"}

      foreach server $::DataAcquisition::ACQSERVERS {
          if {$allservers == 0 && $server != $::DataAcquisition::ACQSERVER} continue

          set ::DataAcquisition::ACQSERVER $server

          if {[info exists MIDAS_DataAcquisitionControlServer_Exists]} then {
              set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetState} m]
          } else {
              if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                  set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                  DataAcquisitionControlClient_Configure
              }
              set rc [catch {DataAcquisitionControlClient__GetState} m]
          }

          if {$rc != 0} {
             InsertLog "STATE returned with an error\n$m\n$errorCode\n$errorInfo"
             set AcqCode 6
             set AcqState "error"
             set AcqInfo "unknown"
          } else {
             set AcqCode [lindex $m 1]
             set AcqState [lindex $m 2]
             set AcqInfo [lindex $m 3]
#            InsertLog "STATE returned $acqserver: $AcqState"
          }
          set ::DataAcquisition::AcqSysCode($server) $AcqCode
          set ::DataAcquisition::AcqSysState($server) $AcqState
      }
      set ::DataAcquisition::ACQSERVER $BAK

      if {$allservers == 0} {return $AcqCode} 

#    monitoring multiple systems
#    logic to set a return code when not all are the same 

      set i 0
      foreach server $::DataAcquisition::ACQSERVERS {
          if {$i == 0} {
              set AcqCode $::DataAcquisition::AcqSysCode($server)
              incr i
          } else {
              if {$::DataAcquisition::AcqSysCode($server) != $AcqCode} {
                 set AcqCode 8; set AcqState "Complex"; set AcqInfo "complex state"
#                 set ::DataAcquisition::AcqSysCode($server) 8
#                 set ::DataAcquisition::AcqSysState($server) "Undefined"
                 return $AcqCode
              }
          }
      }

      return $AcqCode
   }


   proc system {args} {

         set cgidata [ncgi::nvlist]

         set w [first [lindex $cgidata 1]]
         set cmd [second [lindex $cgidata 1]]

         switch -glob $cmd {

             DOLOAD   {do_setopt "SoftwareReload"}
             RAWDATA  {Information "[do_getopt RawData]"}
             do_stop  -
             do_go    -
             do_reset -
             do_setup {$cmd}
             default  {InsertLog "unexpected system command:  $cmd"}
         }
   }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       variable HistEnable
       variable XferEnable

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {
                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   DORESET    {do_reset}
                   DOSETUP    {do_setup}
                   DOSTOP     {do_stop}
                   DOGO       {do_go}

                   UPDATESTATE -
                   UPDATE    {}

                   SERVER     {set ::DataAcquisition::ACQSERVER $vl}
                   ALLSERVERS {variable allservers; set allservers [expr ($allservers + 1) & 1]}

                   HIST     {
                       switch $vl {
                           on  {set HistEnable 1}
                           off {set HistEnable 0}
                       }
                       do_setopt "HistEnable=$HistEnable"
                   }

                   XFER     {
                       if {[do_getstate] != 0} {InsertLog "You cannot change this when GOING"; return}
                       switch $vl {
                           on  {set XferEnable 1}
                           off {set XferEnable 0}
                       }
                       do_setopt "XferEnable=$XferEnable"
                   }

                   SYSTEM   {system}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
       }

       do_getstate
       set HistEnable [do_getopt "HistEnable"]
       set XferEnable [do_getopt "XferEnable"]
    }

}   ;# end of if {$started == 0}




