

#    generic register access procedures
#    used by the implementation procedures which only execute within the embedded Linux

   proc ReadVMERegister {Name} {
       global errorCode errorInfo
       variable Rmsg

       set z [catch {::namespace inscope ::urn:VMEAccessServer ReadRegister $Name} Rmsg]

       if {$z == 0} {
           set rc [lindex $Rmsg 5]
# puts "ReadRegister $Name returned $rc  [format 0x%x $rc]"
#           InsertLog "ReadRegister $Name returned $rc  [format 0x%x $rc]"
       } else {
           puts "ReadRegister failed: Name=$Name; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
       return $rc
   }

   proc WriteVMERegister {Name Data} {
       global errorCode errorInfo
       variable Wmsg

# InsertLog "WriteRegister $Name $Data [format 0x%x $Data]"
       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegister $Name $Data} Wmsg]

       if {$z == 0} {
#           InsertLog "WriteRegister $Name $Data [format 0x%x $Data] returned: [lindex $Wmsg 5]"
#           InsertLog "WriteRegister $Name $Data [format 0x%x $Data]"
       } else {
           puts "WriteRegister failed: Name=$Name; Data=$Data; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
   }

   proc WriteVMERegisters {Name Data} {
       global errorCode errorInfo
       variable Wmsg

# InsertLog "WriteRegisters $Name $Data [format 0x%x $Data]"
       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegisters $Name $Data} Wmsg]

       if {$z == 0} {
#           InsertLog "WriteRegisters $Name $Data [format 0x%x $Data] returned: [lindex $Wmsg 5]"
#           InsertLog "WriteRegisters $Name $Data [format 0x%x $Data]"
       } else {
           puts "WriteRegisters failed: Name=$Name; Data=$Data; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
   }

   proc ReadVMERegisterAttr {Name} {
       global errorCode errorInfo
       variable Rmsg

       set z [catch {::namespace inscope ::urn:VMEAccessServer ReadRegisterAttributes $Name} Rmsg]

       if {$z == 0} {
           set rc [lindex $Rmsg 5]
# puts "ReadRegisterAttributes $Name returned $rc  [format 0x%x $rc]"
#           InsertLog "ReadRegisterAttributes $Name returned $rc  [format 0x%x $rc]"
       } else {
           puts "ReadRegisterAttributes failed: Name=$Name; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
       return $rc
   }

 proc WriteAIDARegister {Addr Vl}  {
    global errorCode errorInfo

        set rc [catch {::namespace inscope ::urn:XAIDAAccessServer do_Set $Addr $Vl} m]
        if {$rc != 0} {
#            puts  "WriteAIDARegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
            return $m
        }
}

proc ReadAIDARegister {Addr}  {
    global errorCode errorInfo

        set rc [catch {interp eval "" ::namespace inscope ::urn:XAIDAAccessServer do_Get $Addr} m]
        if {$rc != 0} {
#            puts  "ReadAIDARegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
            return $m
        }
}

   proc ReadNetVar {Name} {
       global errorCode errorInfo
       variable Rmsg

       set z [catch {::namespace inscope ::urn:NetVarService ReadRegister $Name} Rmsg]

       if {$z == 0} {
           set rc [lindex $Rmsg 5]
# puts "ReadRegister $Name returned $rc  [format 0x%x $rc]"
#           InsertLog "ReadRegister $Name returned $rc  [format 0x%x $rc]"
       } else {
           puts "ReadRegister failed: Name=$Name; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
       return $rc
   }

   proc WriteNetVar {Name Data} {
       global errorCode errorInfo
       variable Wmsg

# InsertLog "WriteRegister $Name $Data [format 0x%x $Data]"
       set z [catch {::namespace inscope ::urn:NetVarService WriteRegister $Name $Data} Wmsg]

       if {$z == 0} {
#           InsertLog "WriteRegister $Name $Data [format 0x%x $Data] returned: [lindex $Wmsg 5]"
#           InsertLog "WriteRegister $Name $Data [format 0x%x $Data]"
       } else {
           puts "WriteRegister failed: Name=$Name; Data=$Data; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
   }

   proc CreateNetVar {Name Opts} {
       global errorCode errorInfo
       variable Wmsg

       set z [catch {::namespace inscope ::urn:NetVarService DefineRegister  $Name NetVar $Opts} Wmsg]

       if {$z == 0} {
#           puts "DefineRegister returned: [lindex $Wmsg 5]"
           set errorCode 0
       } else {
           puts "DefineRegister failed: Name=$Name; Opts=$Opts; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
       return $errorCode
   }

   proc CreateSigTask {Name Opts} {
       global errorCode errorInfo
       variable Wmsg

       set z [catch {::namespace inscope ::urn:SigTaskService DefineRegister  $Name SigTask $Opts} Wmsg]

       if {$z == 0} {
#           puts "DefineRegister returned: [lindex $Wmsg 5]"
           set errorCode 0
       } else {
           puts "DefineRegister failed: Name=$Name; Opts=$Opts; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
       return $errorCode
   }

   proc WriteSigTask {Name Data} {
       global errorCode errorInfo
       variable Wmsg

       set z [catch {::namespace inscope ::urn:SigTaskService WriteRegister  $Name $Data} Wmsg]

       if {$z == 0} {
#          puts "WriteRegister returned: [lindex $Wmsg 5]"
           set errorCode 0
       } else {
           puts "WriteRegister failed: Name=$Name; Data=$Data; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
       return $errorCode
   }

   proc WriteSigTaskAttr {Name Data} {
       global errorCode errorInfo
       variable Wmsg

       set z [catch {::namespace inscope ::urn:SigTaskService WriteRegisterAttributes  $Name $Data} Wmsg]

       if {$z == 0} {
#           puts "WriteRegisterAttributes returned: [lindex $Wmsg 5]"
           set errorCode 0
       } else {
           puts "WriteRegisterAttributes failed: Name=$Name; Data=$Data; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
       return $errorCode
   }


 proc DBSetValue {name value} {
       variable LogFlag
       global errorCode errorInfo
       global MIDAS_DataBaseCode

       set project $::DataAcquision::PROJECT

       set Path [set ::[set project]::DBRootName]/[set ::[set project]::DBNodeBase]/[first [split $name .]]

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_set $Path $name $value int} m]
        if {$rc != 0} {
            InsertLog "set returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
                if {$name == "NULL"} then {
                    InsertLog "$Path created"
                } else {
                    if {$LogFlag == 1} {InsertLog "$Path: $name set to $value"}
                }
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path $name NOT set: error [second $m]; [third $m]"
            }
        }
  }

  proc DBGetValue {name} {
       variable LogFlag
       global errorCode errorInfo
       global MIDAS_DataBaseCode

       set project $::DataAcquision::PROJECT

       set Path [set ::[set project]::DBRootName]/[set ::[set project]::DBNodeBase]/[first [split $name .]]

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_get $Path $name} m]
        if {$rc != 0} {
            InsertLog "set returned with an error\n$m\n$errorCode\n$errorInfo"
            set value "Error!"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
                if {$LogFlag == 1} {InsertLog "$Path: $name = $m"}
                set value "$m"
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path $name NOT available: error [second $m]; [third $m]"
                set value "Error!"
            }
        }
        return $value
  }

  proc DBCreateNode {Path} {
       variable LogFlag
       global errorCode errorInfo
       global MIDAS_DataBaseCode

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_set $Path NULL NULL NULL} m]
        if {$rc != 0} {
            InsertLog "set returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
               InsertLog "$Path created"
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path NOT created: error [second $m]; [third $m]"
            }
        }
  }

    proc DBGetNodes {Path Pattern} {
       variable LogFlag
        global errorCode errorInfo
        global MIDAS_DataBaseCode

        set nodeList {}

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_nodes $Path $Pattern} m]
        if {$rc != 0} {
            InsertLog "nodes returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode >= 0} then {
                if {$MIDAS_DataBaseCode == 0} then {
                     if {$LogFlag == 1} {InsertLog "$Path contains nodes"}
                     set nodeList {}
                     foreach item $m {
                         lappend nodeList $item
                         if {$LogFlag == 1} {InsertLog "$item"}
                     }
                } else {
                     if {$LogFlag == 1} {InsertLog "$Path contains no nodes"}
                }
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path access error: error [second $m]; [third $m]"
            }
        }
        return $nodeList
    }

   proc set_Options {} {}
   proc load_Options {} {}
   proc update_Options {} {}


