

#    support for Web Service access  -  provides application specific support

global MIDAS_DataAcquisitionControlServer_Verbose
set MIDAS_DataAcquisitionControlServer_Verbose 0

#   include other program files

global env

    set f [file join $env(MIDASBASE) TclHttpd Html RunControl common.tcl]
    set z [catch {source $f} m]
    if {$z != 0} {puts "RunControl returned z=$z and $m"}

    set f [file join $env(MIDASBASE) TclHttpd Html RunControl sys.tcl]
    set z [catch {source $f} m]
    if {$z != 0} {puts "RunControl returned z=$z and $m"}

    set f [file join $env(MIDASBASE) TclHttpd Html RunControl stats.tcl]
    set z [catch {source $f} m]
    if {$z != 0} {puts "RunControl returned z=$z and $m"}


variable NUM 48
for {set i 0} {$i < $NUM} {incr i} {set Stats($i) 0}
for {set i 0} {$i < $NUM} {incr i} {set Rates($i) 0}

variable SYS_DataAcquisitionCode  0

variable RunControlDelay1 100
variable RunControlDelay2 50
variable RunControlDelay3 500



proc Appdo_Setup {args} {
    variable SYS_DataAcquisitionCode
    variable RunControlDelay1

# puts "do_Setup:  Acquisition state = $SYS_DataAcquisitionCode args = $args"

    after $RunControlDelay1 {
        set z [catch {::namespace inscope ::urn:DataAcquisitionControlServer do_SetUpC} m]
        if {$z != 0} {puts "do_Setup gets $m"}
    }

   set SYS_DataAcquisitionCode 3

# puts "Setup: DataAcquisitionCode = $SYS_DataAcquisitionCode"
}

proc do_SetUpC {} {
    variable SYS_DataAcquisitionCode

     set z [catch {doSetUp} m]            ;#  this is in sys.tcl
     if {$z != 0} {
puts "SetUpC: $m"
        set SYS_DataAcquisitionCode 6     ;# error
     } else {
        set SYS_DataAcquisitionCode 0     ;#  state = STOPPED
     }

# puts "SetupC: DataAcquisitionCode = $SYS_DataAcquisitionCode"
}

proc Appdo_Reset {args} {
    variable SYS_DataAcquisitionCode
    variable RunControlDelay1

# puts "do_Reset:  Acquisition state = $SYS_DataAcquisitionCode args = $args"

    after $RunControlDelay1 {
        set z [catch {::namespace inscope ::urn:DataAcquisitionControlServer do_ResetC} m]
        if {$z != 0} {puts "do_Reset gets $m"}
    }

   set SYS_DataAcquisitionCode 7

# puts "Reset: DataAcquisitionCode = $SYS_DataAcquisitionCode"
}

proc do_ResetC {} {
    variable SYS_DataAcquisitionCode

     set z [catch {doReset} m]       ;#   this is in sys.tcl
     if {$z != 0} {
puts "ResetC: $m"
        set SYS_DataAcquisitionCode 6     ;# error
     } else {
        set SYS_DataAcquisitionCode 2     ;#  state = RESET
     }

# puts "ResetC: DataAcquisitionCode = $SYS_DataAcquisitionCode"
}

proc Appdo_Stop {args} {
    variable SYS_DataAcquisitionCode
    variable RunControlDelay1

# puts "do_Stop:  Acquisition state = $SYS_DataAcquisitionCode args = $args"

    after $RunControlDelay1 {
        set z [catch {::namespace inscope ::urn:DataAcquisitionControlServer do_StopC} m]
        if {$z != 0} {puts "do_Stop gets $m"}
    }

   set SYS_DataAcquisitionCode 5

# puts "Stop: DataAcquisitionCode = $SYS_DataAcquisitionCode"
}

proc do_StopC {} {
    variable SYS_DataAcquisitionCode

     set z [catch {doStop} m]         ;#    this is in sys.tcl
     if {$z != 0} {
puts "StopC: $m"
        set SYS_DataAcquisitionCode 6     ;# error
     } else {
        set SYS_DataAcquisitionCode 0     ;#  state = STOPPED
     }

# puts "StopC: DataAcquisitionCode = $SYS_DataAcquisitionCode"
}

proc Appdo_Go {args} {
    variable SYS_DataAcquisitionCode
    variable RunControlDelay1

# puts "do_Go:  Acquisition state = $SYS_DataAcquisitionCode args = $args"

    after $RunControlDelay1 {
        set z [catch {::namespace inscope ::urn:DataAcquisitionControlServer do_GoC} m]
        if {$z != 0} {puts "do_Go gets $m"}
    }

   set SYS_DataAcquisitionCode 4

# puts "Go: DataAcquisitionCode = $SYS_DataAcquisitionCode"
}

proc do_GoC {} {
    variable SYS_DataAcquisitionCode

     set z [catch {doGo} m]        ;#   this is in sys.tcl
     if {$z != 0} {
puts "GoC: $m"
        set SYS_DataAcquisitionCode 6     ;# error
     } else {
        set SYS_DataAcquisitionCode 1     ;#  state = GOING
     }

# puts "GoC: DataAcquisitionCode = $SYS_DataAcquisitionCode"
}

proc Appdo_GetState {args} {
    variable SYS_DataAcquisitionCode

# puts "Get_State:  Acquisition state = $SYS_DataAcquisitionCode args = $args"

    if {$SYS_DataAcquisitionCode == 0} {set SYS_DataAcquisitionCode [DataAcqState]}
    if {$SYS_DataAcquisitionCode == 1} {set SYS_DataAcquisitionCode [DataAcqState]}
    if {$SYS_DataAcquisitionCode == 8} {set SYS_DataAcquisitionCode [DataAcqState]}

# puts "Get_State DataAcquisitionCode = $SYS_DataAcquisitionCode"

     return $SYS_DataAcquisitionCode
}

proc Appdo_SetOption {args} {
   global env

   if {[llength $args] == 1} {set args [first $args]}

   set state [lindex $args 0]
   set opt [lindex $args 1]

   set cmd [first [split $opt =]]
   set vl [second [split $opt =]]

   switch $cmd {
        ClearStats  {
          set z [catch {do_clearstats} m]
          if {$z != 0} {puts "RunControl returned z=$z and $m"}
        }
        SoftwareReload   {
          set z [catch {source $env(ProjectRunControlImplementation)} m]
          if {$z != 0} {puts "RunControl returned z=$z and $m"}
   
            puts "Project RunControl Implementation reloaded"
        }
        HistEnable {WriteNetVar NetVar.DACQ.Chistenable $vl}
        XferEnable {WriteNetVar NetVar.DACQ.Ctxenable $vl}
        default    {puts "SetOption: Unknown Acquisition Option state=$state; opt=\"$opt\"; cmd=$cmd; vl=$vl"}
    }   
}

proc Appdo_GetOption {args} {   

   if {[llength $args] == 1} {set args [first $args]}

   set state [lindex $args 0]
   set opt [lindex $args 1]

   set cmd [first $opt]

   set rc "none"

    switch $cmd {
       RawData    {set rc [Dump_Raw_Data]}
       HistEnable {set rc [ReadNetVar NetVar.DACQ.Chistenable]}
       XferEnable {set rc [ReadNetVar NetVar.DACQ.Ctxenable]}
       default    {puts "GetOption: Unknown Acquisition Option state=$state; opt=\"$opt\"; cmd=$cmd"}
    }   

    return "$rc"
}

proc Appdo_GetCounters {{block 0}} {
    variable NUM
    variable Stats

#   puts "do_GetCounters:"

    do_update $block

    set rc ""
    for {set i 0} {$i < $NUM} {incr i} {append rc "[set Stats($i)] "}

    return $rc
}

proc Appdo_GetRates {{block 0}} {
    variable NUM
    variable Rates

#   puts "do_GetRates:"

    do_update $block

    set rc ""
    for {set i 0} {$i < $NUM} {incr i} {append rc "[set Rates($i)] "}

    return $rc
}


